<?php
define( 'ELFCHAT_PATH'  , "./" );
include_once("kernel/elfchat.php");
include_once("classes/chat.php");
include_once("skin/skin_main.php");

class PublicChat extends Chat
{
	function __construct($kr)
	{
		parent::__construct($kr);
	}

	function Content()
	{
		$scripts = "
		  <script type='text/javascript' src='js/jquery.js'></script>
		  <script type='text/javascript' src='js/JsHttpRequest.js'></script>
		  <script type='text/javascript' src='js/soundmanager.js'></script>
		  <div id='soundbox' style='position: absolute;'></div> 
		  <script type='text/javascript' src='js/elfchat.js'></script> 
		";
		Skin::Header(array(
		"title" => "",
		"settings" => $this->kernel->settings,
		"scripts" => $scripts,
		"chattype" => "public",
		"det" => "default",
		"showExitLink" => true,
		));

		$room = $this->kernel->db->room($this->kernel->user['room']);

		Skin::PublicChat($this->kernel->settings, $this->kernel->user, $room['name']);
		Skin::Footer();
	}

	function Send()
	{
		include_once("./classes/JsHttpRequest.php");
		$JsHttpRequest =& new JsHttpRequest("UTF-8");
		global $_RESULT;

		//xss security
		$msg = $this->TextPreform($_REQUEST['msg']);

		include_once("smiles/smiles.php");
		foreach ($smiles as $src=>$smile)
		{
			$sma = explode(' ', $smile);
			foreach ($sma as $rp)
			{
				$msg = str_replace($rp, '<img src="smiles/'.$src.'">', $msg);
			}
		}

		$this->kernel->db->send($this->kernel->user['room'], $this->kernel->user['name'], $this->kernel->user['htmlname'], microtime(true), 'msg', $msg);
		$_RESULT = array(
		"send"     => true,
		);
	}

	function Load()
	{
		include_once("./classes/JsHttpRequest.php");
		$JsHttpRequest =& new JsHttpRequest("UTF-8");
		global $_RESULT;
		if(mt_rand(1,1000) <= 5)
		{
			$this->kernel->timeout();
		}

		$result = $this->kernel->db->load($this->kernel->user['room'], $_REQUEST['lid']);

		// to return
		$reget = array();

		// public messages
		if(count($result) > 0)
		{
			// Флаг - обновить список онлайн
			$updateOnlineList = false;
			// Форматируем
			$i = 0;
			for(; $i < count($result); $i++)
			{
				$reget[$i]['id'] = $result[$i]['id'];
				$reget[$i]['ty'] = $result[$i]['type'];
				$reget[$i]['ti'] = date($this->kernel->settings['timeformat'], round($result[$i]['time'],0));
				$reget[$i]['n']  = $result[$i]['name'];
				$reget[$i]['hn'] = stripslashes($result[$i]['htmlname']);
				$reget[$i]['m']  = $result[$i]['msg'];

				if($reget[$i]['ty'] == 'msg')
				{
					if(strpos($reget[$i]['m'], stripslashes($this->kernel->user['name'])) !== false)$reget[$i]['ty'] = 'you';
				}
				else if($reget[$i]['ty'] == 'enter'  ||
				$reget[$i]['ty'] == 'exit'   ||
				$reget[$i]['ty'] == 'chroom'    ||
				$reget[$i]['ty'] == 'kill'   ||
				$reget[$i]['ty'] == 'ban'    ||
				$reget[$i]['ty'] == 'timeout' )$updateOnlineList = true;
			}

			if($updateOnlineList)
			{
				$_RESULT['uol'] = 1;
			}
		}

		$private = $this->kernel->db->check_new_privat($this->kernel->user['det']);

		// private messages
		if(count($private) > 0)
		{
			foreach($private as $row)
			{
				$reget[$i]['id'] = $row['id'];
				$reget[$i]['ty'] = 'privat';
				$reget[$i]['ti'] = date($this->kernel->settings['timeformat'], time());
				$reget[$i]['n'] = $row['name'];
				$reget[$i]['hn'] = $row['htmlname'];
				$reget[$i]['m'] = $row['fromdet'];
			}

			$this->kernel->db->privat_all_read($this->kernel->user['det']);
		}


		if(count($reget) > 0)
		{
			$_RESULT['msgs'] = array_reverse($reget);
		}
	}

	function Online()
	{
		include_once("./classes/JsHttpRequest.php");
		$JsHttpRequest =& new JsHttpRequest("UTF-8");
		global $_RESULT;
		if(mt_rand(1,100) <= 20)
		{
			$this->kernel->timeout();
		}

		$allusers = $this->kernel->db->onlinelist();  //$this->kernel->user['room']

		//SECURITY: DONT RETURN MID!
		$reget = array();
		$j = 0;
		for ($i = 0; $i < count($allusers); $i++)
		{
			if($allusers[$i]['room'] == $this->kernel->user['room'])
			{
				//$reget[$i]['ti']	= date($kernel->settings['timeformat'], round($allusers[$i]['time'],0));
				$reget[$j]['d']	= $allusers[$i]['det'];
				$reget[$j]['n']	= $allusers[$i]['name']; // Остовляем слэши, так как отображается в вызове функции
				$reget[$j]['hn'] = stripslashes($allusers[$i]['htmlname']);
				if($allusers[$i]['status'] == '')
				{
					if(time() - $allusers[$i]['time'] > $this->kernel->settings['offlinetime'])
					{
						$reget[$j]['st'] = 'off';
					}
					else
					{
						$reget[$j]['st'] = 'on';
					}
				}
				else
				{
					$reget[$j]['st'] = $allusers[$i]['status'];
				}

				$j++;
			}
		}

		$ar = array();
		if($this->kernel->settings['roomon'])
		{
			$allrooms = $this->kernel->db->allrooms();
			$j = 0;
			for ($i = 0; $i < count($allrooms); $i++)
			{
				if($allrooms[$i]['id'] != $this->kernel->user['room'])
				{
					$ar[$j]['id'] = $allrooms[$i]['id'];
					$ar[$j]['n'] = $allrooms[$i]['name'];

					$ar[$j]['c'] = 0;
					foreach ($allusers as $user) if($user['room'] == $ar[$j]['id']) $ar[$j]['c']++;

					if($allrooms[$i]['password'] != "")
					{
						$ar[$j]['p'] = true;
					}
					else
					{
						$ar[$j]['p'] = false;
					}

					$j++;
				}
			}
		}

		$_RESULT = array(
		"ols" => array_reverse($reget),
		"ar" => $ar,
		);
	}
}

$puca = new PublicChat($kernel);
$puca->Login();


