<?php
abstract class Auth
{
	var $session_name = '';
	var $users = array();
	var $keyname_user = '';
	var $keyname_hash = '';

	function __construct($session_name, $users, $keyname_user = 'user', $keyname_hash = 'hash')
	{
		$this->session_name = $session_name;
		$this->users = $users;
		$this->keyname_user = $keyname_user;
		$this->keyname_hash = $keyname_hash;
	}

	function Check()
	{
		if(isset($_SESSION[$this->keyname_user]) && isset($_SESSION[$this->keyname_hash])
		&& sha1( $this->users[$_SESSION[$this->keyname_user]] . sha1(date('YmdH')) . sha1($this->IPDetect()) ) == $_SESSION[$this->keyname_hash])
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function TryLogin()
	{
		if(isset($_POST[$this->keyname_user]) && isset($_POST[$this->keyname_hash]))
		{
			$_SESSION[$this->keyname_user] = $_POST[$this->keyname_user];
			$_SESSION[$this->keyname_hash] = sha1( sha1($_POST[$this->keyname_hash]) . sha1(date('YmdH')) . sha1($this->IPDetect()) );
		}
	}

	function TryExit()
	{
		if(isset($_POST['exit']) || isset($_GET['exit']))
		{
			$_SESSION[$this->keyname_user] = '';
			$_SESSION[$this->keyname_hash] = '';
			session_destroy();
			return true;
		}
		else
		{
			return false;
		}
	}

	function Login()
	{
		session_name($this->session_name);
		session_start();

		if($this->TryExit())
		{
			$this->ExitForm();
		}
		else
		{
			$this->TryLogin();
			if($this->Check())
			{
				$this->Content();
			}
			else
			{
				$this->LoginForm();
			}
		}
	}

	function Content() {}
	function LoginForm() {}
	function ExitForm() {}	
	
	private function IPDetect() 
	{
		$serverVars = array(
		"HTTP_X_FORWARDED_FOR",
		"HTTP_X_FORWARDED",
		"HTTP_FORWARDED_FOR",
		"HTTP_FORWARDED",
		"HTTP_VIA",
		"HTTP_X_COMING_FROM",
		"HTTP_COMING_FROM",
		"HTTP_CLIENT_IP",
		"HTTP_XROXY_CONNECTION",
		"HTTP_PROXY_CONNECTION",
		"HTTP_USERAGENT_VIA"
		);
		foreach ($serverVars as $serverVar) {
			if (!empty($_SERVER) && !empty($_SERVER[$serverVar]))
			$proxyIP = $_SERVER[$serverVar];
			elseif (!empty($_ENV) && isset($_ENV[$serverVar]))
			$proxyIP = $_ENV[$serverVar];
			elseif (@getenv($serverVar))
			$proxyIP = getenv($serverVar);
		}
		if (!empty($proxyIP)) {
			$isIP = preg_match('|^([0-9]{1,3}\.){3,3}[0-9]{1,3}|', $proxyIP, $regs);
			$long = ip2long($regs[0]);
			if ($isIP && (sizeof($regs) > 0) && $long != -1 && $long !== false)
			return $regs[0];
		}
		return $_SERVER['REMOTE_ADDR'];
	}	
}
?>