<?php
class sessions
{
	var $kernel;
	
	function start()
	{
		session_name($this->kernel->prefix);
		session_start();
	}
	
	function close()
	{
		session_destroy();
	}

	function logined()
	{
		if(isset($_SESSION['mid']) && $this->kernel->db->logined($_SESSION['mid'], $this->IPDetect()))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function mid()
	{
		return $_SESSION['mid'];
	}
	
	function IPDetect() 
	{
		$serverVars = array(
		"HTTP_X_FORWARDED_FOR",
		"HTTP_X_FORWARDED",
		"HTTP_FORWARDED_FOR",
		"HTTP_FORWARDED",
		"HTTP_VIA",
		"HTTP_X_COMING_FROM",
		"HTTP_COMING_FROM",
		"HTTP_CLIENT_IP",
		"HTTP_XROXY_CONNECTION",
		"HTTP_PROXY_CONNECTION",
		"HTTP_USERAGENT_VIA"
		);
		foreach ($serverVars as $serverVar) {
			if (!empty($_SERVER) && !empty($_SERVER[$serverVar]))
			$proxyIP = $_SERVER[$serverVar];
			elseif (!empty($_ENV) && isset($_ENV[$serverVar]))
			$proxyIP = $_ENV[$serverVar];
			elseif (@getenv($serverVar))
			$proxyIP = getenv($serverVar);
		}
		if (!empty($proxyIP)) {
			$isIP = preg_match('|^([0-9]{1,3}\.){3,3}[0-9]{1,3}|', $proxyIP, $regs);
			$long = ip2long($regs[0]);
			if ($isIP && (sizeof($regs) > 0) && $long != -1 && $long !== false)
			return $regs[0];
		}
		return $_SERVER['REMOTE_ADDR'];
	}
}
?>